/*
 *	$Id:$
 */
#define MODULE
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/fs.h>
#include <asm/uaccess.h>

#define DEV_MAJOR_NO	82
#define DEV_NAME	"bios"

//static int bios_lseek(struct inode *inode, struct file *filp);
static int bios_open(struct inode *inode, struct file *filp);
static int bios_read(struct file *filp, char * buf, size_t count, loff_t *ppos);

//EXPORT_SYMBOL(xxx)

static struct file_operations fileops = {
	NULL,
	bios_read,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	bios_open,
	NULL,	/* flush */
	NULL,	/* release */
	NULL	/* fsync */
};

int init_module(void)
{
	int rc;
	rc = register_chrdev(DEV_MAJOR_NO , DEV_NAME, &fileops);
	return rc;
}

void cleanup_module(void)
{
	unregister_chrdev(DEV_MAJOR_NO , DEV_NAME);
}

static int bios_open(struct inode *inode, struct file *filp)
{
	filp->f_pos = 0x00000000;
	return 0;
}

static int bios_read(struct file *filp, char * buf, size_t count, loff_t *ppos)
{
	int sz = (int)count;
	char *src = (char *)0xbfc00000 + *ppos;
	if (((char *)0xc0000000 - src) < sz) sz = (char *)0xc0000000 - src;
	if (copy_to_user(buf, src, sz)) return -EFAULT;
	*ppos += sz;
	return sz;
}

